<?php
/*
 * $RCSfile: module.inc,v $
 *
 * Gallery - a web based photo album viewer and editor
 * Copyright (C) 2000-2005 Bharat Mediratta
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA.
 */
/**
 * @package Puzzle
 * @version $Revision: 0.9 $ $Date: 2005/11/12 20:28:11 $
 * @author J. Mike Rollins <rollins@CamoTruck.Net>
 */

/**
 * CamoTruck.Net Puzzle Module
 *
 * This module provides support for adding puzzles to items
 *
 * @package Puzzle
 */

class PuzzleOptions extends ItemEditOption 
  {
    function isAppropriate($item, $thumbnail) 
      {
        return array(GalleryStatus::success(), GalleryUtilities::isA($item, 'GalleryAlbumItem'));
      }

    function handleRequestAfterEdit($form, $item, $preferred) 
      {
        // examine the form checkbox value
        if (empty($form['PuzzleOptions']['enabled']) || ($form['PuzzleOptions']['enabled'] == 'off'))
          $status = 'no';
        else if (isset($form['PuzzleOptions']['enabled']) && ($form['PuzzleOptions']['enabled'] == 'on'))
          $status = 'yes';
        else
          // Hmm... this should not happen
          $status = 'yes';

        $ret = GalleryCoreApi::setPluginParameter('module','puzzle','enabled',$status,$item->getId());
        if ($ret->isError()) 
          {
            return array($ret->wrap(__FILE__, __LINE__), null);
          }
        return array(GalleryStatus::success(),null);
      }



    function loadTemplate(&$template, $form, $item, $thumbnail) 
      {
        list ($ret, $enabled) = GalleryCoreApi::getPluginParameter('module','puzzle','enabled',$item->getId());
        if ($ret->isError()) 
          {
            return array($ret->wrap(__FILE__, __LINE__), null);
          }

        if (empty($enabled))
          $PuzzleOptions['enabled']="yes"; // default to yes
        else if ($enabled == "yes")
          $PuzzleOptions['enabled']="yes";
        else if ($enabled == "no")
          $PuzzleOptions['enabled']="no";
        else 
          $PuzzleOptions['enabled']="no"; // Hmm... this should not happen

        $template->setVariable('PuzzleOptions', $PuzzleOptions);

        return array(GalleryStatus::success(),
             'modules/puzzle/templates/PuzzleOptionsTemplate.tpl',
             'modules_puzzle');
    }

}

?>
